#pragma once
#ifndef __RAYTRACE_H
#define __RAYTRACE_H
#include "Def.h"
#include "Texture.h"
#include "Cubemap.h"
#include "Blob.h"

struct materialChannel {
    float diffuse;
    //Deuxime couleur diffuse optionnelle pour les matriaux procduraux
    float diffuse2; 
    float reflection, refraction, density, absorption;
    float specular;
    float power;
};

struct material {
    enum {
        gouraud=0,
        noise=1,
        marble=2,
        turbulence=3
    } type;

    float bump;

    materialChannel tab[color::OFFSET_MAX];

    materialChannel & getChannel(color::OFFSET offset) { return tab[int(offset)]; }
    const materialChannel & getChannel(color::OFFSET offset) const { return tab[int(offset)]; }
};

struct light {
	point pos;
	color intensity;
};

struct context {
    color::OFFSET offset;
    float fRefractionCoef;
    color cLightScattering;
    int   level;
    float absorption;

    static const context & getDefaultAir() 
    {
        static context airContext = {color::OFFSET_GREEN, 1.0f, {0.0f,0.0f,0.0f}, 0, 1.0f};
        return airContext;
    };
};

#define invsqrtf(x) (1.0f / sqrtf(x))

#endif // __RAYTRACE_H
