#pragma once
#ifndef __SCENE_H
#define __SCENE_H
#include <vector>
#include "raytrace.h"

struct perspective {
    enum {
        orthogonal = 0,
        conic = 1
    } type;

    float FOV;
    float clearPoint;
    float dispersion;
};

struct photonMapSettings {
    enum 
    {
        conicEstimator, 
        gaussianEstimator, 
        radianceEstimator
    }
    eFilterType;
    int size;
    bool directLighting;
    int maxNearestPhotons;
    float maxDistanceSquare;
};

struct scene {
    std::vector<material> matTab;
	std::vector<sphere>   sphTab;
	std::vector<blob>     blbTab;
	std::vector<light>    lgtTab;
    photonMapSettings     phMapProp;
    int sizex, sizey;
    enum {
        high, 
        medium, 
        low
    } supersampleType;
    cubemap               cm;
    perspective           persp;
    int                   complexity;
  
};

bool init(char* inputName, scene &myScene);

#endif // __SCENE_H
