#include "Texture.h"
#include <cmath>
#include <fstream>

using namespace std;

color readTexture(const color* tab, float u, float v, int sizeU, int sizeV)
{
    u = fabsf(u);
    v = fabsf(v);
    int umin = int(sizeU * u);
    int vmin = int(sizeV * v);
    int umax = int(sizeU * u) + 1;
    int vmax = int(sizeV * v) + 1;
    float ucoef = fabsf(sizeU * u - umin);
    float vcoef = fabsf(sizeV * v - vmin);
    
    // la texture est adresse sur [0,1]
    // le type d'adressage est la pour
    // determiner comment on gere les
    // coordonnes qui sont en dehors des bornes.
    // par dfaut on ramne ce qui est plus
    // petit que zro  zro
    // et ce qui est plus grand que un  un.
    // (oprateur de saturation ou clamping)

    // Clamping est le dfaut pour les textures
    umin = min(max(umin, 0), sizeU - 1);
    umax = min(max(umax, 0), sizeU - 1);
    vmin = min(max(vmin, 0), sizeV - 1);
    vmax = min(max(vmax, 0), sizeV - 1);

    // Ce qui suit est une interpolation bilinaire
    // selon les deux coordonnes u et v.

    color output = 
        (1.0f - vcoef) * 
        ((1.0f - ucoef) * tab[umin  + sizeU * vmin] 
        + ucoef * tab[umax + sizeU * vmin])
        +   vcoef * 
        ((1.0f - ucoef) * tab[umin  + sizeU * vmax] 
        + ucoef * tab[umax + sizeU * vmax]);
    return output;
}

