#ifndef _PHOTONMAP_H
#define _PHOTONMAP_H

#pragma once
#include "def.h"
#include <vector>

struct photon 
{
    point pos; 
    vecteur dir ; 
    // vecteur normal;
    // float wattage; 
    // DWORD flag; 
};

struct priorityHeap 
{
    float maxDistSquare;
    std::vector<std::pair<float, const photon*> > resultTab;
};

class photonmap{
    float fLastMaxDistSquare;
    float fSecondLastMaxDistance;
    class photoncache *container;
    int number;
    float wattagePerPhoton;

    void locatePhotons (const point& pos, const vecteur &normal, float fMinCos, int nPhotons, float & maxDistSquare, std::vector<std::pair<float, int> > & result, int firstNode);

public:
    bool reserve(int myNumber);
    int findNearestPhotons (const point& pos, const vecteur & normal, float maxAngle, int number, priorityHeap & result);

    bool addPhoton (const photon & newPhoton, const vecteur & newNormal);

    float getWattagePerPhoton() {return wattagePerPhoton;}
    void setWattagePerPhoton(float newWattagePerPhoton) {wattagePerPhoton = newWattagePerPhoton;}

    photonmap() : fLastMaxDistSquare(0), fSecondLastMaxDistance(0), container(0), number(0), wattagePerPhoton(0.0f) {};
    ~photonmap();
};


#endif // _PHOTONMAP_H
