#pragma once
#ifndef _RAY_H
#define _RAY_H

#include "def.h"

struct ray {
	point start;
	vecteur dir;
};

bool findIntersection(/*IN*/const ray viewRay, 
                      /*IN*/const struct scene & myScene, 
                      /*OUT*/struct point &ptHitPoint, 
                      /*OUT*/struct vecteur &vNormal, 
                      /*OUT*/struct material &currentMat, 
                      /*OUT*/float &distance);

bool LookForDiffuse(/*IN*/const ray &viewRay,
                   /*IN*/const struct point &ptHitPoint, 
                   /*IN*/const struct vecteur &vNormal, 
                   /*IN*/const struct materialChannel &currentMatChannel, 
                   /*IN*/ bool bInside,
                   /*IN-OUT*/ struct context &myContext,
                   /*OUT*/ ray &outRay);

#endif // _RAY_H
